/*
 * xpfdagstest.c: Just runs routines in xpf_interface.c: for debugging only.
 * INCREDIBLY DIFFICULT TO UNDERSTAND, LAST USED IN DEC 1993.
 */

#include <stdio.h>
extern int xpfPrintf();
extern int exit();
extern int gettimeofday();
#include <sys/time.h>
#include "xpf.h"
#include "xpf_internal.h"

#define DONTDOIT 1
#define LARRY	1
#define SUFFIX 1

int
main()
{
	XPFObject	pf;
	XPFPattern	*srcpatternlist;
	XPFFilter	*srcfilterlist;
#if	MERGEINFO
	XPFInfoList	*pinfo = XPF_INFO_NULL;
	XPFInfoList	*pdelinfo = XPF_INFO_NULL;
	XPFInfoList	info;
#else	MERGEINFO
	XPFInformation	pinfo = XPF_INFO_NULL;
	XPFInformation	*pdelinfo = XPF_INFO_NULL;
	XPFInformation	info;
#endif	MERGEINFO
	int		message[6];	/* header length is 24, and there's 1 header, 4 bytes extra: total 24 */
#if	LARRY
	struct timeval	begin, end;
	int		i;
#endif	LARRY
	XPFPattern	*prefix, *new, *suffix;
	XPFFilter	*rest;
	XPFSetupArg	a;
	XPFSetupSuffixArg b;
	XPFRemoveArg	c;
	unsigned char	msg1[4096];
	unsigned char	msg2[952];
	int		len1 = 4096;
	int		len2 = 952;

	xpfPrintf("+++++++++++++ main ++++++++++++++\n");

	/*
	 * Test Parameters:
	 * 1. Fixed/Variable length headers: to test during Get.
	 * 2. Overlapping masks+values/disjoint: to test now.
	 * 3. Dynamic keys, Session lists, Message lists (delay) or not: to test during actual processing.
	 * 4. Single/Multiple protocol(s): to test now and during Get.
	 */

	if (!xpfCreateObject(&pf)) exit (2);
	setup_udpip_pattern(pf, 9600, (192<<24) + (12<<16) + (69 << 8) + 111);
	/* Test for a two fragment message with proper fields set: 16..19=destaddr, 9=protid, 6..7=morefrag, 4..5=msgid, 22..23=destport */

	msg1[16] = 192;
	msg1[17] = 12;
	msg1[18] = 69;
	msg1[19] = 111;
	msg1[9] = 17;
	msg1[6] = 0x20;
	msg1[7] = 0x00;
	*(unsigned short *)(&msg1[22]) = 9600;

	msg2[16] = 192;
	msg2[17] = 12;
	msg2[18] = 69;
	msg2[19] = 111;
	msg2[9] = 17;
	msg2[6] = 0x00;
	msg2[7] = 0x00;
	*(unsigned short *)(&msg2[22]) = 9600;

	for (i=0; i<20; i++) {
		*(unsigned short *)&(msg1[4]) = i;
		*(unsigned short *)&(msg2[4]) = i;
		printf("%x ", xpf_read(pf, msg1, len1));
		printf("%x ", xpf_read(pf, msg2, len2));
	}
	xpfPrintPATTree(((XPFState *)pf)->xpfAssociationSet);
	remove_udpip_pattern(pf, 9600, (192<<24) + (12<<16) + (69 << 8) + 111);

	/*
	setup_udpip_pattern(pf, 9600, (192<<24) + (12<<16) + (69 << 8) + 111);
	remove_udpip_pattern(pf, 9600, (192<<24) + (12<<16) + (69 << 8) + 111);
	remove_udpip_pattern(pf, 9600, (192<<24) + (12<<16) + (69 << 8) + 111);
	*/
	exit(0);

	xpfCreatePattern(srcpatternlist);
	xpfInitializeFixedHeader(&srcpatternlist->header, 24);

	xpfCreateFilter(srcfilterlist);
	xpfInitializeSelector(&srcfilterlist->extractor.selector, 12, 0, 1);
	xpfInitializeExtractor(&srcfilterlist->extractor, XPF_DATA_INT, 0xffffffff);
	xpfInitializeFilter(srcfilterlist, 0x123456, NULL);
	xpfInitializePattern(srcpatternlist, srcfilterlist, NULL, 0, 1, NULL);

	xpfCreateFilter(srcfilterlist->next);
	xpfInitializeSelector(&srcfilterlist->next->extractor.selector, 16, 0, 1);
	xpfInitializeExtractor(&srcfilterlist->next->extractor, XPF_DATA_INT, 0xffffffff);
	xpfInitializeFilter(srcfilterlist->next, 0xabcdef, NULL);

	xpfCreateProgram(srcpatternlist->programlist);
	xpfInitializeSelector(&srcpatternlist->programlist->extractor.selector, 2, 0, 4);
	xpfInitializeExtractor(&srcpatternlist->programlist->extractor, XPF_DATA_INT, 0xffffffff);
	xpfInitializeProgram(srcpatternlist->programlist, NULL);

#if	MERGEINFO
	info.information = (XPFDataUnit *)100;
	info.next = XPF_INFO_NULL;
	a.information = &info;
#else	MERGEINFO
	info = (XPFInformation)100;
	a.information = info;
#endif	MERGEINFO
	a.pattern = srcpatternlist;
	xpfPrintf("setup returned: %d\n", xpf_ioctl(pf, XPF_SETUP, &a, 4));
	xpfPrintf("information: after setup 100\n");
	srcpatternlist->header.headertype = 0;	/* might be changed while inserting */

#if	DONTDOIT
#define LOOKUPNOW	1

#if	LOOKUPNOW
	message[0] = message[1] = 0;
	message[2] = 0x1010;
	message[3] = 0x123456;
	message[4] = 0xabcdef;
	pinfo = XPF_INFO_NULL;
	xpfPrintf("lookup returned: %d\n", pinfo = xpf_read(pf, (XPFMessage)message, 24));
	if (pinfo != XPF_INFO_NULL) {
#if	MERGEINFO
		xpfPrintf("information: after lookup %d\n", pinfo->information);
		pinfo->information += 1;	/* changed after lookup */
#else	MERGEINFO
		xpfPrintf("information: after lookup %d\n", pinfo);
		pinfo += 1;	/* changed after lookup */
#endif	MERGEINFO
	}

	message[4] = 0xbbbbb;	/* should match 101 now */
	pinfo = XPF_INFO_NULL;
	pdelinfo = XPF_INFO_NULL;
	xpfPrintf("lookup returned: %d\n", pinfo = xpf_read(pf, (XPFMessage)message, 24));
	if (pinfo != XPF_INFO_NULL)
#if	MERGEINFO
		xpfPrintf("information: after lookup %d\n", pinfo->information);
#else	MERGEINFO
		xpfPrintf("information: after lookup %d\n", pinfo);
#endif	MERGEINFO
#if	MERGEINFO
	if (pdelinfo != XPF_INFO_NULL) xpfPrintf("deletedinfo = %d\n", pdelinfo->information);
#endif	MERGEINFO

	message[4] = 0xabcdef;
	message[2] = 0x2020;	/* Now to test deletion of old programs */
	pinfo = XPF_INFO_NULL;	/* must get 100, and old one should go */
	pdelinfo = XPF_INFO_NULL;
	xpfPrintf("lookup returned: %d\n", pinfo = xpf_read(pf, (XPFMessage)message, 24));
	if (pinfo != XPF_INFO_NULL)
#if	MERGEINFO
		xpfPrintf("information: after lookup %d\n", pinfo->information);
#else	MERGEINFO
		xpfPrintf("information: after lookup %d\n", pinfo);
#endif	MERGEINFO
#if	MERGEINFO
	if (pdelinfo != XPF_INFO_NULL) xpfPrintf("deletedinfo = %d\n", pdelinfo->information);
#endif	MERGEINFO
	message[2] = 0x3030;
	pinfo = XPF_INFO_NULL;	/* must get 100 since this is spawned afresh */
	pdelinfo = XPF_INFO_NULL;
	xpfPrintf("lookup returned: %d\n", pinfo = xpf_read(pf, (XPFMessage)message, 24));
	if (pinfo != XPF_INFO_NULL)
#if	MERGEINFO
		xpfPrintf("information: after lookup %d\n", pinfo->information);
#else	MERGEINFO
		xpfPrintf("information: after lookup %d\n", pinfo);
#endif	MERGEINFO
#if	MERGEINFO
	if (pdelinfo != XPF_INFO_NULL) xpfPrintf("deletedinfo = %d\n", pdelinfo->information);
#endif	MERGEINFO
	message[2] = 0x1010;
	pinfo = XPF_INFO_NULL;	/* must get 100 since this is spawned afresh */
	pdelinfo = XPF_INFO_NULL;
	xpfPrintf("lookup returned: %d\n", pinfo = xpf_read(pf, (XPFMessage)message, 24));
	if (pinfo != XPF_INFO_NULL)
#if	MERGEINFO
		xpfPrintf("information: after lookup %d\n", pinfo->information);
#else	MERGEINFO
		xpfPrintf("information: after lookup %d\n", pinfo);
#endif	MERGEINFO
#if	MERGEINFO
	if (pdelinfo != XPF_INFO_NULL) xpfPrintf("deletedinfo = %d\n", pdelinfo->information);
#endif	MERGEINFO
#endif	LOOKUPNOW

#if	LARRY
	/*
	 * Do the test Larry wanted: how much time for each lookup operation?
	 */
	gettimeofday(&begin, NULL);
	for (i=0; i<10000; i++) xpf_read(pf, (XPFMessage)message, 24);
	gettimeofday(&end, NULL);
	xpfPrintf("10000 Lookups took %d ms\n", (end.tv_sec*1000 + end.tv_usec/1000) - (begin.tv_sec*1000 + begin.tv_usec/1000));
#endif	LARRY

#if	NULLKEY
	/* Try if NULL keys are working */
	srcpatternlist->filterlist->extractor.selector.offset = 12;
	srcpatternlist->filterlist->extractor.selector.level = 0;
	*(int*)srcpatternlist->filterlist->extractor.mask = 0xffffffff;
	*(int*)srcpatternlist->filterlist->value = 0x123456;
	srcpatternlist->filterlist->next->extractor.selector.offset = 0;
	srcpatternlist->filterlist->next->extractor.selector.level = 0;
	srcpatternlist->filterlist->next->extractor.datatype = XPF_NONE;
	*(int*)srcpatternlist->filterlist->next->extractor.mask = 0;
	*(int*)srcpatternlist->filterlist->next->value = 0;
#if	MERGEINFO
	info.information = (XPFDataUnit *)2;
	a.information = &info;
#else	MERGEINFO
	info = (XPFInformation)2;
	a.information = info;
#endif	MERGEINFO
	a.patternlist = srcpatternlist;
	xpf_ioctl(pf, XPF_SETUP, &a, 4);
#endif	NULLKEY
#endif	DONTDOIT

	/* setup might change stuff */
	srcpatternlist->filterlist->extractor.selector.offset = 12;
	srcpatternlist->filterlist->extractor.selector.level = 0;
	*(int*)srcpatternlist->filterlist->extractor.mask = 0xffffffff;
	*(int*)srcpatternlist->filterlist->value = 0x123456;
	srcpatternlist->filterlist->next->extractor.selector.offset = 16;
	srcpatternlist->filterlist->next->extractor.selector.level = 0;
	*(int*)srcpatternlist->filterlist->next->extractor.mask = 0xffffffff;
	*(int*)srcpatternlist->filterlist->next->value = 0xabcdef;

#if	DELETE
	/* Deletion test */
	pinfo = XPF_INFO_NULL;
	c.pattern = srcpatternlist;
	c.info = NULL;
	xpfPrintf("remove returned: %d\n", xpf_ioctl(pf, XPF_REMOVE, &c, 4));
	if (pinfo != XPF_INFO_NULL)
#if	MERGEINFO
		xpfPrintf("information: after remove %d\n", pinfo->information);
#else	MERGEINFO
		xpfPrintf("information: after remove %d\n", pinfo);
#endif	MERGEINFO
	message[0] = message[1] = message[2] = 0;
	message[3] = 0x123456;
	message[4] = 0xabcdef;
	pinfo = XPF_INFO_NULL;
	xpfPrintf("lookup returned: %d\n", pinfo = xpf_read(pf, (XPFMessage)message, 24));
	if (pinfo != XPF_INFO_NULL)
#if	MERGEINFO
		xpfPrintf("information: after lookup %d\n", pinfo->information);
#else	MERGEINFO
		xpfPrintf("information: after lookup %d\n", pinfo);
#endif	MERGEINFO
	a.information = pinfo;
	a.pattern = srcpatternlist;
	xpf_ioctl(pf, XPF_SETUP, &a, 4);
#endif	DELETE

	srcfilterlist = (XPFFilter *)xpfMalloc(sizeof(XPFFilter));
/*
	srcfilterlist->next = srcpatternlist->filterlist;
	srcpatternlist->filterlist = srcfilterlist;
*/
	srcpatternlist->filterlist->next->next = srcfilterlist;
	xpfInitializeSelector(&srcfilterlist->extractor.selector, 20, 0, 1);
	xpfInitializeExtractor(&srcfilterlist->extractor, XPF_DATA_INT, 0xffffffff);
	xpfInitializeFilter(srcfilterlist, 0xab908000, NULL);

	xpfCreateProgram(srcpatternlist->programlist);	/* destroy the old one */
	xpfInitializeSelector(&srcpatternlist->programlist->extractor.selector, 1, 0, 4);
	xpfInitializeExtractor(&srcpatternlist->programlist->extractor, XPF_DATA_INT, 0xffffffff);
	xpfInitializeProgram(srcpatternlist->programlist, NULL);

#if	MERGEINFO
	info.information = (XPFDataUnit *)300;
	a.information = &info;
#else	MERGEINFO
	info = (XPFInformation)300;
	a.information = info;
#endif	MERGEINFO
	a.pattern = srcpatternlist;
	xpfPrintf("setup returned: %d\n", xpf_ioctl(pf, XPF_SETUP, &a, 4));
	xpfPrintf("information: after setup 300\n");

#if	SUFFIX
	prefix = (XPFPattern *)xpfMalloc(sizeof(XPFPattern));
	xpfMemcpy(&prefix->header, &srcpatternlist->header, sizeof(XPFHeader));
	prefix->header.headertype = 0;
	prefix->programlist = NULL;
	prefix->filterlist = srcpatternlist->filterlist;

	suffix = (XPFPattern *)xpfMalloc(sizeof(XPFPattern));
	xpfMemcpy(&suffix->header, &srcpatternlist->header, sizeof(XPFHeader));
	suffix->header.headertype = 0;
	suffix->programlist = NULL;
	suffix->filterlist = srcpatternlist->filterlist->next;

	rest = srcpatternlist->filterlist->next->next;
	prefix->filterlist->next = NULL;
	suffix->filterlist->next = NULL;

	new = (XPFPattern *)xpfMalloc(sizeof(XPFPattern));
	xpfMemcpy(&new->header, &srcpatternlist->header, sizeof(XPFHeader));
	new->header.headertype = 0;
	new->programlist = NULL;
	xpfCreateFilter(srcfilterlist);
	xpfInitializeSelector(&srcfilterlist->extractor.selector, 8, 0, 1);
	xpfInitializeExtractor(&srcfilterlist->extractor, XPF_DATA_INT, 0xffffffff);
	xpfInitializeFilter(srcfilterlist, 0xfedcba, NULL);
	new->filterlist = srcfilterlist;

	xpfPrintf("*******************************\n");

#if	MERGEINFO
	info.information = (XPFDataUnit *)500;
	b.information = &info;
#else	MERGEINFO
	info = (XPFInformation)500;
	b.information = info;
#endif	MERGEINFO
	b.prefix = prefix;
	b.new = new;
	b.findsuffix = suffix;
	xpfPrintf("setup returned: %d\n", xpf_ioctl(pf, XPF_SETUPSUFFIX, &b, 4));
	xpfPrintf("information: after setup 500\n");

	message[0] = message[1] = 0;
	message[2] = 0xfedcba;
	message[3] = 0x123456;
	message[4] = 0;
	message[5] = 0;
	pinfo = XPF_INFO_NULL;	/* must give 500 */
	xpfPrintf("lookup returned: %d\n", pinfo = xpf_read(pf, (XPFMessage)message, 24));
	if (pinfo != XPF_INFO_NULL)
#if	MERGEINFO
		xpfPrintf("information: after lookup %d\n", pinfo->information);
#else	MERGEINFO
		xpfPrintf("information: after lookup %d\n", pinfo);
#endif	MERGEINFO

	message[5] = 0xab908000;
	pinfo = XPF_INFO_NULL;	/* must give 300 */
	xpfPrintf("lookup returned: %d\n", pinfo = xpf_read(pf, (XPFMessage)message, 24));
	if (pinfo != XPF_INFO_NULL)
#if	MERGEINFO
		xpfPrintf("information: after lookup %d\n", pinfo->information);
#else	MERGEINFO
		xpfPrintf("information: after lookup %d\n", pinfo);
#endif	MERGEINFO
#endif	SUFFIX
	exit(0);
#if	DONTDOIT
#if	LOOKUPLATER
	message[0] = message[1] = 0;
	message[2] = 0x1010;
	message[3] = 0x123456;
	message[4] = 0xabcdef;
	pinfo = XPF_INFO_NULL;
	xpfPrintf("lookup returned: %d\n", pinfo = xpf_read(pf, (XPFMessage)message, 24));
	if (pinfo != XPF_INFO_NULL) {
#if	MERGEINFO
		xpfPrintf("information: after lookup %d\n", pinfo->information);
		pinfo->information += 1;	/* changed after lookup */
#else	MERGEINFO
		xpfPrintf("information: after lookup %d\n", pinfo);
		pinfo += 1;	/* changed after lookup */
#endif	MERGEINFO
	}

	message[4] = 0xbbbbb;	/* should match 101 now */
	pinfo = XPF_INFO_NULL;
	xpfPrintf("lookup returned: %d\n", pinfo = xpf_read(pf, (XPFMessage)message, 24));
	if (pinfo != XPF_INFO_NULL)
#if	MERGEINFO
		xpfPrintf("information: after lookup %d\n", pinfo->information);
#else	MERGEINFO
		xpfPrintf("information: after lookup %d\n", pinfo);
#endif	MERGEINFO
#endif	LOOKUPLATER

	xpfPrintf("---------- now doing longest match tests ----------\n");

	message[0] = message[1] = 0x10101010;
	message[2] = 0x101010;
	message[3] = 0x123456;
	message[4] = 0xabcdef;
	message[5] = 0xab908000;
	pinfo = XPF_INFO_NULL;
	xpfPrintf("lookup returned: %d\n", pinfo = xpf_read(pf, (XPFMessage)message, 24));
	if (pinfo != XPF_INFO_NULL) {
#if	MERGEINFO
		xpfPrintf("information: after lookup %d\n", pinfo->information);
		pinfo->information += 1;
#else	MERGEINFO
		xpfPrintf("information: after lookup %d\n", pinfo);
		pinfo += 1;
#endif	MERGEINFO
	}
#if	0
	message[4] = 0xbbbbbbbb;	/* still matches 301 */
	message[2] = 0x1010;		/* should not match 101 -- still matches 301? */
#endif	0
	pinfo = XPF_INFO_NULL;
	xpfPrintf("lookup returned: %d\n", pinfo = xpf_read(pf, (XPFMessage)message, 24));
	if (pinfo != XPF_INFO_NULL)
#if	MERGEINFO
		xpfPrintf("information: after lookup %d\n", pinfo->information);
#else	MERGEINFO
		xpfPrintf("information: after lookup %d\n", pinfo);
#endif	MERGEINFO
#if	LARRY
	/*
	 * Do the test Larry wanted: how much time for each lookup operation?
	 */
	gettimeofday(&begin, NULL);
	for (i=0; i<10000; i++) xpf_read(pf, (XPFMessage)message, 24);
	gettimeofday(&end, NULL);
	xpfPrintf("10000 Lookups took %d ms\n", (end.tv_sec*1000 + end.tv_usec/1000) - (begin.tv_sec*1000 + begin.tv_usec/1000));
#endif	LARRY

	/* setup might change stuff */
	srcpatternlist->header.size.fixed = 24;
	srcpatternlist->header.headertype = 0;
	srcpatternlist->filterlist->extractor.selector.offset = 8;
	srcpatternlist->filterlist->extractor.selector.level = 0;
	*(int*)srcpatternlist->filterlist->extractor.mask = 0xffffffff;
	*(int*)srcpatternlist->filterlist->value = 0xab908000;
	srcpatternlist->filterlist->next->extractor.selector.offset = 12;
	srcpatternlist->filterlist->next->extractor.selector.offset = 0;
	*(int*)srcpatternlist->filterlist->next->extractor.mask = 0xffffffff;
	*(int*)srcpatternlist->filterlist->next->value = 0x123456;
	srcpatternlist->filterlist->next->next->extractor.selector.offset = 16;
	srcpatternlist->filterlist->next->next->extractor.selector.offset = 0;
	*(int*)srcpatternlist->filterlist->next->next->extractor.mask = 0xffffffff;
	*(int*)srcpatternlist->filterlist->next->next->value = 0xabcdef;

#if	DELETE
	/* Deletion test */
	pinfo = XPF_INFO_NULL;
	c.pattern = srcpatternlist;
	c.info = NULL;
	xpfPrintf("remove returned: %d\n", xpf_ioctl(pf, XPF_REMOVE, &c, 4);
	if (pinfo != XPF_INFO_NULL)
#if	MERGEINFO
		xpfPrintf("information: after remove %d\n", pinfo->information);
#else	MERGEINFO
		xpfPrintf("information: after remove %d\n", pinfo);
#endif	MERGEINFO
	pinfo = XPF_INFO_NULL;
	xpfPrintf("lookup returned: %d\n", pinfo = xpf_read(pf, (XPFMessage)message, 24));
	if (pinfo != XPF_INFO_NULL)
#if	MERGEINFO
		xpfPrintf("information: after lookup %d\n", pinfo->information);
#else	MERGEINFO
		xpfPrintf("information: after lookup %d\n", pinfo);
#endif	MERGEINFO
	a.information = pinfo;
	a.pattern = srcpatternlist;
	xpf_ioctl(pf, XPF_SETUP, &a, 4);
#endif	DELETE

#if	OVERLAPP
	xpfPrintf("******************************\n");

	/* Now test for overlappping stuff: note that insert can destroy contents of the filterlist but not the structure */

	xpfCreatePattern(srcpatternlist);
	xpfInitializeFixedHeader(&srcpatternlist->header, 24);

	xpfCreateFilter(srcfilterlist);
	xpfInitializeSelector(&srcfilterlist->next->extractor.selector, 8, 0, 1);
	xpfInitializeExtractor(&srcfilterlist->next->extracror, XPF_DATA_INT, 0xffffffff);
	xpfInitializeFilter(srcfilterlist->next, 0xab907fff, NULL);
	xpfInitializePattern(srcpatternlist, srcfilterlist, NULL, 0, 1, NULL);

	xpfCreateFilter(srcfilterlist->next);
	xpfInitializeSelector(&srcfilterlist->next->extractor.selector, 12, 0, 1);
	xpfInitializeExtractor(&srcfilterlist->next->extractor, XPF_DATA_INT, 0xffffffff);
	xpfInitializeFilter(srcfilterlist->next, 0x654321, NULL);

	xpfCreateFilter(srcfilterlist->next->next);
	xpfInitializeSelector(&srcfilterlist->next->next->extractor.selector, 16, 0, 1);
	xpfInitializeExtractor(&srcfilterlist->next->next->extractor, XPF_DATA_INT, 0xffffffff);
	xpfInitializeFilter(srcfilterlist->next->next, 0xfedcba, NULL);

#if	MERGEINFO
	info.information = (XPFDataUnit *)4;
	a.information = &info;
	a.pattern = srcpatternlist;
	xpf_ioctl(pf, XPF_SETUP, &a, 4);
#else	MERGEINFO
	info = (XPFInformation)4;
	a.information = info;
	a.pattern = srcpatternlist;
	xpf_ioctl(pf, XPF_SETUP, &a, 4);
#endif	MERGEINFO
	srcpatternlist->header.headertype = 0;
	message[0] = message[1] = 0;
	message[2] = 0xab907fff;
	message[3] = 0x654321;
	message[4] = 0xfedcba;
	pinfo = XPF_INFO_NULL;
	xpfPrintf("lookup returned: %d\n", pinfo = xpf_read(pf, (XPFMessage)message, 24));
	if (pinfo != XPF_INFO_NULL)
#if	MERGEINFO
		xpfPrintf("information: after lookup %d\n", pinfo->information);
#else	MERGEINFO
		xpfPrintf("information: after lookup %d\n", pinfo);
#endif	MERGEINFO
#if	MERGEINFO
	info.information = (XPFDataUnit *)5;
	a.information = &info;
	a.patternlist = srcpatternlist;
	xpf_ioctl(pf, &a, 4);
#else	MERGEINFO
	info = (XPFInformation *)5;
	a.information = info;
	a.patternlist = srcpatternlist;
	xpf_ioctl(pf, &a, 4);
#endif	MERGEINFO
	srcpatternlist->header.headertype = 0;
	message[0] = message[1] = 0;
	message[2] = 0xbbbbbbbb;
	message[3] = 0x654321;
	message[4] = 0xfedcba;
	pinfo = XPF_INFO_NULL;
	xpfPrintf("lookup returned: %d\n", pinfo = xpf_read(pf, (XPFMessage)message, 24));
	if (pinfo != XPF_INFO_NULL)
#if	MERGEINFO
		xpfPrintf("information: after lookup %d\n", pinfo->information);
#else	MERGEINFO
		xpfPrintf("information: after lookup %d\n", pinfo);
#endif	MERGEINFO

#endif	OVERLAPP
	/* Overlapp test also works */
#endif	DONTDOIT
	return 0;
}
